<template>
  <div id="courseManagement">
    <search-box-new
      ref="searchBox"
      :formData="formData"
      :formList="formList"
      @search="search"
      @init="init"
    />
    <table-list
      :tableSets="tableSet"
      :tableData="tableData"
      :navText="navText"
      @addClick="addClick"
      :loading="loading"
      @editInfo="editInfo"
      ref="tableList"
      rowKey="courseId"
    >
      <template slot="customize">
        <el-button size="medium" @click="batchDel" type="warning"
          >批量删除</el-button
        >
      </template>
      <template slot="btn" slot-scope="props">
        <el-button type="text" @click="edit(props.scope.row, 1)"
          >基本信息</el-button
        >
        <el-button type="text" @click="edit(props.scope.row, 2)"
          >章节内容</el-button
        >
        <!-- <el-button type="text" @click="edit(props.scope.row)">修改</el-button> -->
        <el-button type="text" @click="del(props.scope.row)">删除</el-button>
      </template>
    </table-list>
    <pagination
      :total="total"
      :pageSize="formData.pageSize"
      :currentPage="formData.pageNum"
      @handleSizeChange="handleSizeChange"
      @handleCurrentChange="handleCurrentChange"
    />
  </div>
</template>

<script>
import searchBoxNew from "@/components/searchBoxNew";
import tableList from "@/components/tableList";
import pagination from "@/components/pagination";
import { courseBatchDel } from "@/api/resource/videoManagement";
export default {
  name: "CourseManagement",
  components: { searchBoxNew, tableList, pagination },
  data() {
    return {
      loading: false, //当前表单加载是否加载动画
      navText: {
        title: "课程管理",
        index: 0,
        ch: "条",
        num: true,
        border: true,
        choice: true,
        addHide: false,
        changeWidth: "220px",
        openCheckMore: true,
        backFatherBtn: {
          status: false,
          title: "未定义",
        },
      },
      //搜索
      formList: [
        {
          prop: "educationTypeId",
          placeholder: "教育类型",
          scope: "educationType",
        },
        {
          prop: "businessId",
          placeholder: "业务层次",
          scope: "businessLevel",
          edu: "educationTypeId",
        },
        {
          prop: "schoolId",
          placeholder: "院校",
          scope: "schoolList",
          edu: "educationTypeId",
        },
        {
          prop: "majorId",
          placeholder: "专业",
          scope: "Professional",
          edu: "educationTypeId",
        },
        {
          prop: "subjectId",
          placeholder: "科目",
          scope: "sujectType",
          edu: "educationTypeId",
        },
        {
          prop: "prefixName",
          placeholder: "请输入标题前缀",
        },
        {
          prop: "publishStatus",
          placeholder: "发布状态",
          scope: "select",
          options: [
            {
              label: "发布",
              value: 1,
            },
            {
              label: "未发布",
              value: 0,
            },
          ],
        },
        {
          prop: "courseName",
          placeholder: "请输入课程名称",
          scope: false,
        },
      ],
      formData: {
        status: "0,1",
        pageSize: 10,
        pageNum: 1,
      },
      // 表单
      tableSet: [
        {
          label: "课程编码",
          prop: "code",
          hidden: false,
        },
        {
          label: "名称前缀",
          prop: "prefixName",
          hidden: false,
        },
        {
          label: "课程名称",
          prop: "courseName",
          hidden: true,
          scope: "editInfo",
        },
        {
          label: "科目",
          prop: "subjectName",
          hidden: true,
        },
        {
          label: "专业",
          prop: "categoryName",
          hidden: false,
        },
        {
          label: "院校",
          prop: "schoolName",
          hidden: false,
        },
        {
          label: "业务层次",
          prop1: "projectName",
          prop2: "businessName",
          hidden: true,
          scope: "InfoMore",
        },
        {
          label: "教育类型",
          prop: "educationName",
          hidden: true,
        },
        {
          label: "发布状态",
          prop: "publishStatus",
          hidden: true,
          scope: "fabStatus",
        },
        {
          label: "最后编辑时间",
          prop: "updateTime",
          scope: "aTimeList",
          hidden: true,
        },
        {
          label: "创建时间",
          prop: "createTime",
          scope: "aTimeList",
          hidden: true,
        },
        // {
        //   label: "课程章节",
        //   prop: "courseId",
        //   hidden: true,
        //   scope: "aboutTrees",
        // },
        {
          label: "关联商品",
          hidden: true,
          prop: "goodsList",
          prop1: "goodsName",
          scope: "aboutChapter",
          int: 4,
        },
      ],
      tableData: [], //表单数据
      total: 0, //一共多少条
      pageSize: 10, //每页多少条数据
      currentPage: 1, //当前页码
    };
  },
  mounted() {
    this.search();
  },
  activated() {
    this.search();
  },
  methods: {
    batchDel() {
      if (!this.$refs.tableList.allCheckData.length) {
        this.$message.warning("请勾选需要删除的课程");
        return;
      }
      this.$confirm(
        `此操作将永久删除所勾选的${this.$refs.tableList.allCheckData.length}条课程, 是否继续?`,
        "提示",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(() => {
          console.log(5646)
          const ids = this.$refs.tableList.allCheckData.map(
            (item) => item.courseId
          );
          courseBatchDel({
            status: -1,
            ids,
          }).then((res) => {
            this.$message.success("批量删除成功");
            this.$refs.tableList.clearMoreActive();
            this.search(1);
          });
        })
        .catch(() => {});
    },
    edit(v, int) {
      const jump = () => {
        this.$router.push({
          path: "editCourse",
          query: {
            id: v.courseId,
            name: int,
          },
        });
      };
      const statusPage = this.$store.state.tagsView.visitedViews.some(
        (item) => {
          return item.name == "EditCourse";
        }
      );
      if (statusPage) {
        this.$store
          .dispatch("tagsView/delCachedView", {
            name: "EditCourse",
          })
          .then((res) => {
            jump();
          });
      } else {
        jump();
      }
    },
    editInfo(v) {
      this.edit(v, 1);
    },
    search(int) {
      this.loading = true;
      if (int === 1) {
        this.formData.pageNum = 1;
      }
      if (int === 2) {
        this.formData = {
          status: "0,1",
          pageSize: 10,
          pageNum: 1,
        };
      }
      this.$api
        .inquireCourseListS(this.formData)
        .then((res) => {
          this.tableData = res.rows;
          this.total = res.total;
          this.navText.index = res.total;
        })
        .finally(() => {
          this.loading = false;
        });
    },
    init() {
      this.search(2);
    },
    del(v) {
      this.$api.gradecheckGoodsChange({ courseId: v.courseId }).then((res) => {
        if (res.data > 0) {
          this.$message.error("已有学员正在学习该课程，无法删除");
          return;
        } else {
          this.$alert(
            "确定删除此内容？<br />内容删除后将无法恢复，请慎重考虑",
            "提示",
            {
              dangerouslyUseHTMLString: true,
            }
          )
            .then(() => {
              var data = {
                courseId: v.courseId,
                status: -1,
              };
              this.$api.editCourse(data).then((res) => {
                this.$message.success("删除成功");
                this.search();
              });
            })
            .catch(() => {
              this.$message({
                type: "info",
                message: "已取消删除",
              });
            });
        }
      });
    },
    addClick(v, int) {
      if (v === undefined) {
        this.$router.push({
          path: "basicInfoAdd",
        });
      } else {
        if (int === 1) {
          this.$router.push({
            path: "chapterContent",
            query: {
              id: v.courseId,
            },
          });
        } else {
          this.$router.push({
            path: "BasicInfoEdit",
            query: {
              id: v.courseId,
            },
          });
        }
      }
    },
    handleSizeChange(v) {
      this.formData.pageSize = v;
      this.formData.pageNum = 1;
      this.search();
    },
    handleCurrentChange(v) {
      this.formData.pageNum = v;
      this.search();
    },
  },
};
</script>

<style lang="less" scoped>
/deep/.el-button {
  border-radius: 8px;
}
/deep/.el-dialog {
  border-radius: 8px;
  .el-dialog__header {
    padding: 0;
    .hearders {
      height: 40px;
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 0px 18px 0px 20px;
      border-bottom: 1px solid #e2e2e2;
      .leftTitle {
        font-size: 14px;
        font-weight: bold;
        color: #2f4378;
      }
      .rightBoxs {
        display: flex;
        align-items: center;
        img {
          width: 14px;
          height: 14px;
          margin-left: 13px;
          cursor: pointer;
        }
      }
    }
  }
  .el-dialog__footer {
    padding: 0;
    .dialog-footer {
      padding: 0px 40px;
      height: 70px;
      border-top: 1px solid #e2e2e2;
      display: flex;
      align-items: center;
      justify-content: flex-end;
    }
  }
}
.imgBox {
  width: 100%;
  // height: 210px;
  border: 1px solid #e2e2e2;
  border-radius: 8px;
  padding: 8px 8px 3px;
  display: flex;
  flex-direction: column;
  align-items: center;
  .imgLabel {
    flex: 1;
    width: 100%;
    border: 1px dotted #e2e2e2;
    color: #999;
    font-size: 14px;
    cursor: pointer;
    border-radius: 8px;
    .msPhoto {
      display: flex;
      justify-content: center;
      align-items: center;
      max-width: 100%;
      max-height: 270px;
      img {
        max-width: 100%;
        max-height: 270px;
      }
    }
    .imgbbx {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      width: 100%;
      height: 100%;
      i {
        font-weight: bold;
        margin: 14px 0;
        font-size: 24px;
      }
    }
  }
  p {
    margin: 5px 0px;
  }
}
</style>